Subject: Re: Repost, different list...File::Spec, cygwin, Syntactic vs. Semantic path analysis
From: Kurt Starsinic <[email-masked]>
To: "linda w (cyg)" <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Thu, 9 Jan 2003 18:01:16 -0500

On Jan 09, linda w (cyg) wrote:
> > Cygwin targets POSIX compatibility wherever possible. Any 
> > discussion about paths that ignores the POSIX standards will 
> > need to be reviewed with POSIX in mind. It's easier to do 
> > that up front.
> ---
> 	What were the _original_ design goals of Cygwin -- i.e. as 
> sponsored by "RedHat"?
> 
> 	If one claims that the original project pages are irrelevant or not
> appropriate to use as a specification of the project intention, then I'd say
> that Cygwin has been moved off of the original project goals and
> is no longer "the same" project, but something else.  
> 
> 	Changing the original goals to suit the aesthetic sensibilities of
> project maintainers  is very different from creating a useful compatibility
> layer for RedHat customers to port applications from Linux to the Win32
> environment and use those applications and tools _seamlessly_ with *native*
> Win32 applications.  Putting on an 'enterprise' hat, I don't want my Win32 or
> Linux sys admins to have to learn to use separate path syntaxes depending on
> which tool they are using in the Win32 environment.  A project goal/feature
> that was listed was the ability to use Win32 tools intermixed with usage of
> Unix [redhat linux] utils.
> 
> 	Under any major, user-oriented version of Unix that I am aware
> of, "//" is reduced to "/" by the *OS*.  This is perfectly POSIX compliant
> behavior.  The restriction of non-assumptions of "//"=="/" are on _applications_
> that desire to be POSIX compliant -- it is not a restriction on the OS.

    That's not a feature of the OS, it's a feature of the filesystem.
The fact that Unix-like OS's *typically* use ext2fs/ffs/etc. as their
primary filesystems, and that MS OS's *typically* use, um, any of
about seven filesystems with a variety of case-sensitivity, maximum-
filename-length, valid characterset, path separator, and directory
structure permutations is orthogonal.

    Your sysadmins don't need to learn different path syntaxes for
different *environments*, but they do for different *filesystems*.  You
can mount an HPFS filesystem on a Linux box, and you can mount an FFS
filesystem on a Windows box.  Either way, you will have to cope.

    - Kurt

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Bug reporting:         http://cygwin.com/bugs.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/